/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.7f Evaluation
Automatic Program Generator
 Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com
e-mail:office@hpinfotech.com

Project : 
Version : 
Date    : 23/01/2008
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments: 


Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/
#include <mega8535.h>
// I2C Bus functions
#asm
   .equ __i2c_port=0x18 ;PORTB
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm
#include <i2c.h>

#include<delay.h>
#include<stdio.h>

// LM75 Temperature Sensor functions
#include <lm75.h>


// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
#include <lcd.h>

#define ADC_VREF_TYPE 0x00

int vit;

// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{     
// Place your code here
if((TCNT1>0)&&(TCNT1<5155))
{
vit = TCNT1;      
}
TCNT1 = 0x00;  

}

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

#include<stdio.h>    
#include<delay.h>


int heyo=0;
// Declare your global variables here

void main(void)
{
// Declare your local variables here  
unsigned int i;
int temp;       
float conversion; 
int nb_impul,pre_etat;
unsigned char tampon[20];



// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0xF0;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 2000,000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Rising Edge
// INT2: Off
GICR|=0x80;
MCUCR=0x0C;
MCUCSR=0x00;
GIFR=0x80;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// I2C Bus initialization
i2c_init();

// LM75 Temperature Sensor initialization
// thyst: 35C
// tos: 40C
// O.S. polarity: 0
lm75_init(7,35,40,0);

// ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: AREF pin
// ADC High Speed Mode: Off
// ADC Auto Trigger Source: None
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x84;
SFIOR&=0xEF;   

// Global enable interrupts
#asm("sei")


// LCD module initialization
lcd_init(16);      
/*
lcd_gotoxy(0,0);                
lcd_putsf("    VisuKart    ");
lcd_gotoxy(0,1);
lcd_putsf("Stan K    Greg D");
lcd_gotoxy(0,2);
lcd_putsf(" le 01/02/2008  ");

lcd_gotoxy(0,3);            
lcd_putsf("       .        ");
delay_ms(400);                

lcd_gotoxy(0,3);            
lcd_putsf("       ..       ");
delay_ms(400);

lcd_gotoxy(0,3);            
lcd_putsf("      ...       ");
delay_ms(400);

lcd_gotoxy(0,3);            
lcd_putsf("     .....      ");    
delay_ms(400);*/
                           
lcd_gotoxy(0,0);
lcd_putsf("    VisuKart    ");
lcd_gotoxy(0,1);
lcd_putsf("    kmh Acc:   %");
lcd_gotoxy(0,2);
lcd_putsf("B:    V T:    \xdfC");   
// lcd_putsf("Bat 42V T:  22*C");   
// lcd_putsf("Bat   V Tmp:22*C"); 
lcd_gotoxy(0,3);            
lcd_putsf("................");



while (1)
      {  
          // Partie batterie  
          i=read_adc(7); // Tension batt
         // sprintf(tampon,"%2d",(int)((float)(i-96)/12.6)); 
         conversion = (float)((float)i*0.0666915732-0.6358820244)*10;
         sprintf(tampon,"%2i.%i",(int)(conversion/10),(int)(conversion-(int)(conversion/10)*10));     
         // sprintf(tampon,"%d",i);
          lcd_gotoxy(2,2);    
         // lcd_gotoxy(0,3);
          lcd_puts(tampon); //on affiche la valeur de i.  
          
          
          
          i=read_adc(2);  // Accelerateur
          sprintf(tampon,"%3d",(int)(i/6));
          lcd_gotoxy(12,1);  
          lcd_puts(tampon);   
          
          
              
          
         
          // Partie temprature
          temp=lm75_temperature_10(0);
          sprintf(tampon,"%2i.%1u",temp/10,temp%10);
          lcd_gotoxy(10,2);
          lcd_puts(tampon);     
          
                     
          
          // Partie vitesse  
      //	sprintf(tampon,"%3i",(int)((float)vit*(float)(-0.0213356071)+(float)110));   	
      sprintf(tampon,"%3i",(int)((float)vit*(float)(-0.005333333)+(float)110));         
	lcd_gotoxy(0,1);          
	lcd_puts(tampon);  
	
	
          delay_ms(100);     
      };
}     
